<script type="text/javascript">


var InterfaceTapas = Class.create( {

    initialize: function( jsonFileFormats, jsonYesNos, jsonObservatories, jsonSpectralUnits, jsonInstrumentalFunctions, jsonClimatoReferences )
    {
        /** *********** CONTAINERS *********** **/
        this.containerForm = $( "#formulaire" );
        this.containerErrors = $( "#errForm" );
        this.containerCenter = $( "#containerCenter" );
        this.containerTabs = $( "#tab" );

        /** *********** VARIABLES *********** **/
        this.jSonFileFormats = jsonFileFormats || null;
        this.jSonYesNos = jsonYesNos || null;
        this.jSonObservatories = jsonObservatories || false;
        this.jSonSpectralUnits = jsonSpectralUnits || null;
        this.jSonInstrumentalFunctions = jsonInstrumentalFunctions || null;
        this.jSonClimatoReferences = jsonClimatoReferences || null;
        this.nbRequest = 1;
        this.tabActive = false;
        this.numRequest = 1;

        var submitButton = new Button( {value:tapasTexts["label.submitButton"], parent:this.containerCenter, id:"button_submit", className: "red_button", classNameText:"red_button_text", onClick:jQuery.proxy( this.onClickSubmit, this )} );
        this.addRequestButton = new Button( {value:tapasTexts["label.addButton"], parent:this.containerCenter, id:"button_add", className: "positive", onClick:jQuery.proxy( this.onClickAdd, this )} );
        this.delRequestButton = new Button( {value:tapasTexts["label.delButton"], parent:this.containerCenter, id:"button_del", className: "negative", onClick:jQuery.proxy( this.onClickDel, this )} );
        this.delRequestButton.disable();

        this.createForm();
        this.tabActive = this.createTab();

        this.containerErrors.hide();
    },


    // CREATES ********************************************************
    createTab:function()
    {
        var ntab = new Tab( {value:tapasTexts["label.requete"] + " " + this.nbRequest, parent:this.containerTabs, numTab: this.nbRequest, id:"tab_request" + this.nbRequest, className: "tab_class", onClick:jQuery.proxy( this.onClickTab, this )} );
        ntab.active();
        return ntab;
    },


    createCalendar: function( containerCalendar, texte, inputDateId, currentDate, isTrToCreate )
    {
        if( isTrToCreate )
        {
            // Create input for date text
            var tr = $( document.createElement( "tr" ) );
            var td1 = $( document.createElement( "td" ) );
            var td2 = $( document.createElement( "td" ) );
            var inputDate = $( document.createElement( "input" ) );
            inputDate.attr( {id:inputDateId, size:"17"} );

            td1.html( texte );
            td1.attr( { class:"containerLabel" } );
            tr.append( td1 );

            td2.attr( {colspan:4} );
            td2.append( inputDate );
            tr.append( td2 );
            containerCalendar.append( tr );
        }

        // Calendar
        this.calendarFormat = "%Y-%m-%d %H:%i:%s";
        this.calendarConverter = new AnyTime.Converter( { format: this.calendarFormat } );

        AnyTime.picker( inputDateId, { format: this.calendarFormat, firstDOW: 1,
            labelTitle: "Select Date", labelYear: "Year", labelMonth: "Month", labelDayOfMonth: "Day",
            labelHour: "Hour", labelMinute: "Minute", labelSecond: "Second"
        } );

        // Ajout de la date courrante ds le calendrier SI currentDate non précisée
        if( !currentDate )
            currentDate = new Date();
        $( "#" + inputDateId ).val( this.calendarConverter.format( currentDate ) );
        $( "#" + inputDateId ).addClass( "calendar" );

    },


    // CREATES ********************************************************
    createTime: function( containerCalendar, texte, inputDateId, currentTime, isTrToCreate )
    {
        if( isTrToCreate )
        {
            // Create input for date text
            var tr = $( document.createElement( "tr" ) );
            var td1 = $( document.createElement( "td" ) );
            var td2 = $( document.createElement( "td" ) );
            var inputDate = $( document.createElement( "input" ) );
            inputDate.attr( {id:inputDateId, size:"10"} );

            td1.html( texte );
            td1.attr( { class:"containerLabel" } );

            tr.append( td1 );


            td2.attr( {colspan:3} );
            td2.append( inputDate );
            tr.append( td2 );
            containerCalendar.append( tr );
        }

        // Time
        this.timeFormat = "%H:%i:%s";
        this.timeConverter = new AnyTime.Converter( { format: this.timeFormat } );

        AnyTime.picker( inputDateId, { format: this.timeFormat, firstDOW: 1,
            labelTitle: "Select hour", labelHour: "Hour", labelMinute: "Minute", labelSecond: "Second"
        } );

        if( !currentTime )
            currentTime = "00:00:00";
        // TODO : voir si besoin de convertir format des heures
//        $( "#" + inputDateId ).val( this.timeConverter.format( currentTime ) );
        $( "#" + inputDateId ).val( currentTime );
        $( "#" + inputDateId ).addClass( "time" );
    },


    createTr: function( texte, inputId, container, textesup )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );

        input.attr( {id: inputId, class:"containerText", size:11} );

        td1.html( texte );
        td1.attr( {class:"containerLabel"} );

        td3.html( textesup );
        td3.attr( {class:"containerLabel2", colspan:3} );
        tr.append( td1 );
        td2.append( input );

        tr.append( td2 );
        tr.append( td3 );
        container.append( tr );

    },

    createSelectYesNo: function( container, name )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + name;
        paramSelect.parent = container;
        var selectYesNos = new Select( paramSelect );
        jQuery.each( this.jSonYesNos, jQuery.proxy( function ( i, jsonYesNo )
        {
            selectYesNos.add( jsonYesNo.value, tapasTexts[jsonYesNo.text] );
        }, this ) );
        selectYesNos.selectFirst( false );
        return selectYesNos;
    },



    createTr2Input: function( texte1, texte2, inputId1, inputId2, container, textesup )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var td3 = $( document.createElement( "td" ) );
        var td4 = $( document.createElement( "td" ) );
        var td5 = $( document.createElement( "td" ) );
        var input1 = $( document.createElement( "input" ) );
        var input2 = $( document.createElement( "input" ) );


        input1.attr( {id: inputId1,class:"containerText",size:11} );
        input2.attr( {id: inputId2,class:"containerText",size:11} );

        td1.html( texte1 );
        td3.html( texte2 );
        td5.html( textesup );
        td1.attr( {class:"containerLabel"} );
        td3.attr( {class:"containerLabel3"} );
        td5.attr( {class:"containerLabel2"} );

        td2.append( input1 );
        //td2.html( texte2 );
        td4.append( input2 );

        tr.append( td1 );
        tr.append( td2 );
        tr.append( td3 );
        tr.append( td4 );
        tr.append( td5 );
        container.append( tr );
    },



    createTrList: function( texte, inputId, container, type )
    {
        var tr = $( document.createElement( "tr" ) );
        var td1 = $( document.createElement( "td" ) );
        var td2 = $( document.createElement( "td" ) );
        var input = $( document.createElement( "input" ) );

        input.attr( {id: inputId} );

        td1.html( texte );
        td1.attr( {class:"containerLabel"} );

        tr.append( td1 );
        if( type == 'format' ) this.displayFileFormats( td2, inputId );
        else if( type == 'yesno' )
        {
            if( (/^(ih2oe_[1-9]+)$/.test( inputId )  ) ) this.select_ih2oe = this.createSelectYesNo( td2, inputId );
            else if( (/^(io2e_[1-9]+)$/.test( inputId )  ) ) this.select_io2e = this.createSelectYesNo( td2, inputId );
            else if( (/^(io3e_[1-9]+)$/.test( inputId )  ) ) this.select_io3e = this.createSelectYesNo( td2, inputId );
            else if( (/^(ico2e_[1-9]+)$/.test( inputId )  ) ) this.select_ico2e = this.createSelectYesNo( td2, inputId );
            else if( (/^(irextinction_[1-9]+)$/.test( inputId )  ) ) this.select_irextinction = this.createSelectYesNo( td2, inputId );
        }
        else if( type == 'observatories' ) this.displayObservatories( td2, inputId );
        else if( type == 'spectralUnit' )
        {
            this.displaySpectralUnits( td2, inputId );
            //td2.attr({colspan:3});
        }
        else if( type == 'ilsf' ) this.displayInstrumentalFunctions( td2, inputId );
        else if( type == 'climatoReference' )
        {
            this.displayClimatoReferences( td2, inputId );
        }

        td2.attr( {colspan:3} );
        tr.append( td2 );
        container.append( tr );
    },


    // REQUESTS ********************************************************
    requestCreateXML: function()
    {
        var tapasForm = this.createTapasObject();
        //passage de javascript a json grace au jquery
        var jsonTapasForm = $.toJSON( tapasForm );


        if( jsonTapasForm )
            $.ajax( {
                url: "data?methodName=createUserRequest&jsonTapas=" + jsonTapasForm,
                success:jQuery.proxy( this.handleCreateXML, this ),
                error: jQuery.proxy( this.showErrors, this )
            } );
    },


    // HANDLES ******************************************************** = retours ajax
    handleCreateXML: function( result )
    {
        // TODO : gérer le bob ??
        var bob = jQuery.parseJSON( result ).result;
        alert( bob );
    },


    // EVENTS ********************************************************
    onClickSubmit: function()
    {
//        if( this.validFields() )
//        {
//            if( confirm( tapasTexts["confirm"] ) )
//            {
//                this.containerErrors.hide();
        this.requestCreateXML();
//            }
//        }
    },


    onClickAdd: function()
    {
        this.containerErrors.hide();
        this.nbRequest++;

        //tabs
        $( ".tab_class" ).removeClass( "activated" );
        this.tabActive = this.createTab();
        this.numRequest = this.tabActive.numTab;

        //formulaires
        $( ".divAll" ).hide();
        this.createForm();

        this.updateButtons();
    },


    onClickDel: function()
    {
        // TODO : enlever le pouet
        if( confirm( "pouet" ) )
        {
            var numCurrent = this.numRequest;
            var z = 1;

            //suppression onglet et form et controles calendrier caché
            $( "#all_" + numCurrent ).remove();
            $( "#tab_request" + numCurrent ).remove();
            AnyTime.noPicker( "iobservation_date_" + numCurrent );
            AnyTime.noPicker( "ira_" + numCurrent );

            this.tabActive.numTab = "1";
            this.numRequest = "1";

            for( var i = 1; i <= this.nbRequest; i++ )
            {
                if( i > numCurrent )
                {
                    z = i - 1;
                    document.getElementById( "all_" + i ).id = "all_" + z;
                    $( "#tab_request" + i ).html( "Request " + z );
                    $( "#tab_request" + i ).attr( {name:z} );
                    //document.getElementById("tab_request"+i).name=z;
                    $( "#tab_request" + i ).attr( {id:"tab_request" + z} );
                    $( "#tabObservation_" + i ).attr( {id:"tabObservation_" + z} );
                    $( "#select_iobservatory_" + i ).attr( {id:"select_iobservatory_" + z} );
                    $( "#select_ispectral_choice_" + i ).attr( {id:"select_ispectral_choice_" + z} );
                    $( "#iminspectral_ranger_" + i ).attr( {id:"iminspectral_ranger_" + z} );
                    $( "#imaxspectral_ranger_" + i ).attr( {id:"imaxspectral_ranger_" + z} );
                    $( "#select_ifunction_" + i ).attr( {id:"select_ifunction_" + z} );
                    $( "#select_icr_" + i ).attr( {id:"select_icr_" + z} );
                    $( "#ide_" + i ).attr( {id:"ide_" + z} );
                    $( "#iza_" + i ).attr( {id:"iza_" + z} );
                    $( "#irp_" + i ).attr( {id:"irp_" + z} );
                    $( "#isr_" + i ).attr( {id:"isr_" + z} );
                    $( "#select_iformat_" + i ).attr( {id:"select_iformat_" + z} );
                    $( "#select_irextinction_" + i ).attr( {id:"select_irextinction_" + z} );
                    $( "#select_ih2oe_" + i ).attr( {id:"select_ih2oe_" + z} );
                    $( "#select_io2e_" + i ).attr( {id:"select_io2e_" + z} );
                    $( "#select_io3e_" + i ).attr( {id:"select_io3e_" + z} );
                    $( "#select_ico2e_" + i ).attr( {id:"select_ico2e_" + z} );

                    // Supression du calendrier puis re-création en insérant l'ancienne date
                    var oldDate = this.calendarConverter.parse( $( "#iobservation_date_" + i ).val() );
                    AnyTime.noPicker( "iobservation_date_" + i );
                    this.createCalendar( $( "#tabObservation_" + z ), tapasTexts["label.datemesure"], "iobservation_date_" + z, oldDate, false );
                    $( "#iobservation_date_" + i ).attr( {id:"iobservation_date_" + z} );

                    // Idem pour les heures !!!
                    // TODO : voir si besoin de parser les heures ou non
//                    var oldTime = this.timeConverter.parse( $( "#ira_" + i ).val() );
                    var oldTime = $( "#ira_" + i ).val();
                    AnyTime.noPicker( "ira_" + i );
                    this.createTime( $( "#tabObservation_" + z ), tapasTexts["label.ira"], "ira_" + z, oldTime, false );
                    $( "#ira_" + i ).attr( {id:"ira_" + z} );
                }
            }

            this.nbRequest--;

            // Mise à jour des boutons
            this.updateButtons();

            //tabs
            $( ".tab_class" ).removeClass( "activated" );
            $( "#tab_request1" ).addClass( "activated" );

            //formulaires
            $( ".divAll" ).hide();
            $( "#all_1" ).show();
        }
    },


    onClickTab: function( event )
    {
        var realTabId = $( "#" + event.currentTarget.id ).attr( "name" );
        var clickedDiv = event.data;

        //tabs
        $( ".tab_class" ).removeClass( "activated" );
        clickedDiv.divContainer.addClass( "activated" );

        //forms
        $( ".divAll" ).hide();
        $( "#all_" + realTabId ).show();

        this.numRequest = realTabId;
        this.tabActive.numTab = realTabId;

        this.updateButtons();
    },


    // OTHERS ********************************************************
    displayFileFormats: function( container, id )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.parent = container;
        this.selectFormats = new Select( paramSelect );
        jQuery.each( this.jSonFileFormats, jQuery.proxy( function ( i, jsonFileFormat )
        {
            this.selectFormats.add( jsonFileFormat.value, jsonFileFormat.text );
        }, this ) );
        this.selectFormats.selectFirst( false );
    },


    displayObservatories: function( container, id )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.name = id;
        paramSelect.parent = container;
        this.selectObservatories = new Select( paramSelect );
        //ajouter select vide avec add
        this.selectObservatories.add( "-1", "-- " + tapasTexts["text.select"] + " --" );
        jQuery.each( this.jSonObservatories, jQuery.proxy( function ( i, jsonObservatory )
        {
            this.selectObservatories.add( jsonObservatory.id, jsonObservatory.name );
        }, this ) );
        this.selectObservatories.selectFirst( true );
    },


    displaySpectralUnits: function( container, id )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.parent = container;
        this.selectSpectralUnits = new Select( paramSelect );
        //ajouter select vide avec add
        this.selectSpectralUnits.add( "-1", "-- " + tapasTexts["text.select"] + " --" );
        jQuery.each( this.jSonSpectralUnits, jQuery.proxy( function ( i, jsonSpectralUnit )
        {
            this.selectSpectralUnits.add( jsonSpectralUnit.value, tapasTexts[jsonSpectralUnit.value] );
            //this.selectSpectralUnits.add( jsonSpectralUnit.value, jsonSpectralUnit.value );
        }, this ) );
        this.selectSpectralUnits.selectFirst( true );
    },

    displayInstrumentalFunctions: function( container, id )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.parent = container;
        this.selectInstrumentalFunctions = new Select( paramSelect );
        //ajouter select vide avec add
        jQuery.each( this.jSonInstrumentalFunctions, jQuery.proxy( function ( i, jsonInstrumentalFunction )
        {
            this.selectInstrumentalFunctions.add( jsonInstrumentalFunction.value, tapasTexts[jsonInstrumentalFunction.text] );
        }, this ) );
        this.selectInstrumentalFunctions.selectFirst( true );
    },


    displayClimatoReferences: function( container, id )
    {
        var paramSelect = new Object();
        paramSelect.id = "select_" + id;
        paramSelect.parent = container;
        this.selectClimatoReferences = new Select( paramSelect );
        //ajouter select vide avec add
        jQuery.each( this.jSonClimatoReferences, jQuery.proxy( function ( i, jsonClimatoReference )
        {
            this.selectClimatoReferences.add( jsonClimatoReference.value, tapasTexts[jsonClimatoReference.text] );
        }, this ) );
        this.selectClimatoReferences.selectFirst( true );
    },


    showErrors: function( result )
    {
        //this.containerErrors.show();
        // this.containerErrors.html( tapasTexts[result.responseText] );
    },



    createForm: function()
    {
        this.divErreurs = $( document.createElement( "div" ) );
        this.divErreurs.addClass( "errorsForm" );
        this.divErreurs.hide();

        var divAll = $( document.createElement( "div" ) );
        divAll.attr( {id:"all_" + this.nbRequest, class:"divAll"} );


        //Creation div
        var divPreference = $( document.createElement( "div" ) );
        var tabPreference = $( document.createElement( "table" ) );
        tabPreference.attr( {cellspacing:3} );

        var divObservation = $( document.createElement( "div" ) );
        var tabObservation = $( document.createElement( "table" ) );
        //tabObservation.attr({border:1});
        tabObservation.attr( {id:"tabObservation_" + this.nbRequest, cellspacing:3} );


        var divAtmosphere = $( document.createElement( "div" ) );
        var tabAtmosphere = $( document.createElement( "table" ) );


        var fieldSetObservation = $( document.createElement( "fieldset" ) );
        fieldSetObservation.addClass( "cfs1" );
        divObservation.append( fieldSetObservation );

        var legendObservation = $( document.createElement( "legend" ) );
        legendObservation.html( "Observation" );
        fieldSetObservation.append( legendObservation );
        legendObservation.addClass( "containerField" );

        var fieldSetPreference = $( document.createElement( "fieldset" ) );
        fieldSetPreference.addClass( "cfs2" );
        divPreference.append( fieldSetPreference );

        var legendPreference = $( document.createElement( "legend" ) );
        legendPreference.html( tapasTexts["label.preferences"] );
        fieldSetPreference.append( legendPreference );
        legendPreference.addClass( "containerField" );

        fieldSetObservation.append( tabObservation );
        divObservation.addClass( "divObservation" );
        divAll.append( divObservation );


        divAtmosphere.append( tabAtmosphere );
        //divAtmosphere.addClass("divAtmosphere");
        //this.containerForm.append( divAtmosphere );
        fieldSetObservation.append( divAtmosphere );

        fieldSetPreference.append( tabPreference );
        divPreference.addClass( "divPreference" );
        divAll.append( divPreference );

        this.containerForm.append( divAll );
        this.containerForm.append( this.divErreurs );
        //this.tabInput = new Array(3);

        this.createTrList( tapasTexts["label.format"], "iformat_" + this.nbRequest, tabPreference, 'format' );
        this.createTrList( tapasTexts["label.era"], "irextinction_" + this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eh2o"], "ih2oe_" + this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eo3"], "io3e_" + this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eo2"], "io2e_" + this.nbRequest, tabPreference, 'yesno' );
        this.createTrList( tapasTexts["label.eco2"], "ico2e_" + this.nbRequest, tabPreference, 'yesno' );

        this.createTrList( tapasTexts["label.observatory"], "iobservatory_" + this.nbRequest, tabObservation, 'observatories' );
        this.createCalendar( tabObservation, tapasTexts["label.datemesure"], "iobservation_date_" + this.nbRequest, false, true );

        //unite
        this.createTrList( tapasTexts["label.spectralUnit"], "ispectral_choice_" + this.nbRequest, tabObservation, 'spectralUnit' );
        this.createTr2Input( tapasTexts["label.spectralRange"], tapasTexts["label.to"], "iminspectral_ranger_" + this.nbRequest, "imaxspectral_ranger_" + this.nbRequest, tabObservation, "[350,2500] nm" );

        //fonction instrumentale
        this.createTrList( tapasTexts["label.ifunction"], "ifunction_" + this.nbRequest, tabObservation, "ilsf" );
        //reference climato
        //this.createTrList( tapasTexts["label.climato"], "icr", tabAtmosphere, "climatoReference" );
        this.createTrList( tapasTexts["label.climato"], "icr_" + this.nbRequest, tabObservation, "climatoReference" );


        //this.createTr( tapasTexts["label.ira"], "ira", tabObservation );
        this.createTime( tabObservation, tapasTexts["label.ira"], "ira_" + this.nbRequest, false, true );
        this.createTr( tapasTexts["label.ide"], "ide_" + this.nbRequest, tabObservation, "hh:mm:ss.ms [-90,90] &deg;" );
        this.createTr( tapasTexts["label.iza"], "iza_" + this.nbRequest, tabObservation, "[0,90] &deg;" );

        this.createTr( tapasTexts["label.resolution"], "irp_" + this.nbRequest, tabObservation, "" );
        this.createTr( tapasTexts["label.ratio"], "isr_" + this.nbRequest, tabObservation, "" );


        //jQuery.proxy permet d'envoyer le contexte this courant

    },



    createTapasObject: function()
    {

        var requests = new Array();

        for( var i = 1; i <= this.nbRequest; i++ )
        {
            // PREFERENCE
            var preference = new Object();

            preference.format = new Object();
            //toutes les valeurs possibles
            preference.format.firstValue = this.selectFormats.getValuesInString();

            //la valeur selectionnee
//            preference.format.secondValue = this.selectFormats.getValue();
            preference.format.secondValue = $( "#select_iformat_" + i )[0].textContent;

            preference.rayleighExtinction = new Object();
            preference.rayleighExtinction.firstValue = this.select_irextinction.getValuesInString();
//            preference.rayleighExtinction.secondValue = this.select_irextinction.getValue();
            preference.rayleighExtinction.secondValue = $( "#select_irextinction_" + i )[0].textContent;

            preference.h2oExtinction = new Object();
            preference.h2oExtinction.firstValue = this.select_ih2oe.getValuesInString();
//            preference.h2oExtinction.secondValue = this.select_ih2oe.getValue();
            preference.h2oExtinction.secondValue = $( "#select_ih2oe_" + i )[0].textContent;

            preference.o3Extinction = new Object();
            preference.o3Extinction.firstValue = this.select_io3e.getValuesInString();
//            preference.o3Extinction.secondValue = this.select_io3e.getValue();
            preference.o3Extinction.secondValue = $( "#select_io3e_" + i )[0].textContent;

            preference.o2Extinction = new Object();
            preference.o2Extinction.firstValue = this.select_io2e.getValuesInString();
//            preference.o2Extinction.secondValue = this.select_io2e.getValue();
            preference.o2Extinction.secondValue = $( "#select_io2e_" + i )[0].textContent;

            preference.co2Extinction = new Object();
            preference.co2Extinction.firstValue = this.select_ico2e.getValuesInString();
//            preference.co2Extinction.secondValue = this.select_ico2e.getValue();
            preference.co2Extinction.secondValue = $( "#select_ico2e_" + i )[0].textContent;


            // OBSERVATION
            var observatory = new Object();
//            observatory.id = this.selectObservatories.getValue();
            observatory.id = $( "#select_iobservatory_" + i )[0].textContent;

            // Los
            var los = new Object();
            los.raJ2000 = $( "#ira_" + i ).val();
            los.decJ2000 = $( "#ide_" + i ).val();
            los.zenithAngle = $( "#iza_" + i ).val();

            // Instrument
            var instrument = new Object();
            instrument.ilsfChoice = new Object();
            instrument.ilsfChoice.firstValue = this.selectInstrumentalFunctions.getValuesInString();
            instrument.ilsfChoice.secondValue = this.selectInstrumentalFunctions.getValue();

            this.selectSpectralUnits.remove( "-1" );
            instrument.spectralChoice = new Object();
            instrument.spectralChoice.firstValue = this.selectSpectralUnits.getValuesInString();
            instrument.spectralChoice.secondValue = this.selectSpectralUnits.getValue();

            instrument.spectralRange = $( "#iminspectral_ranger_" + i ).val() + ' ' + $( "#imaxspectral_ranger_" + i ).val();

            instrument.resolvingPower = new Object();
            instrument.resolvingPower.firstValue = "0";
            instrument.resolvingPower.secondValue = $( "#irp_" + i ).val();

            instrument.samplingRatio = new Object();
            instrument.samplingRatio.firstValue = "0";
            instrument.samplingRatio.secondValue = $( "#isr_" + i ).val();

            var observation = new Object();
            observation.date = this.calendarConverter.parse( $( "#iobservation_date_" + i ).val() );
            observation.observatory = observatory;

            observation.los = los;
            observation.instrument = instrument;

            // ATMOSPHERE
            var atmosphere = new Object();

            atmosphere.reference = new Object();
            atmosphere.reference.firstValue = this.selectClimatoReferences.getValuesInString();
            atmosphere.reference.secondValue = this.selectClimatoReferences.getValue();


            // REQUEST
            var request = new Object();
            request.id = i;
            request.preference = preference;
            request.observation = observation;
            request.atmosphere = atmosphere;

            requests[i-1] = request;
        }

        // TAPAS
        var tapas = new Object();
        tapas.requests = requests;
        return tapas;
    },

    validFields: function()
    {
        var testOk = isSup( this.selectObservatories.getValue(), 0 );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.observatory"] + " : " + tapasTexts["text.toselect"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isDiff( this.selectSpectralUnits.getValue(), -1 );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.spectralUnit"] + " : " + tapasTexts["text.toselect"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isValidRange( $( "#iminspectral_ranger" ).val(), $( "#imaxspectral_ranger" ).val(), this.selectSpectralUnits.getValue() );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.spectralRange"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isDeg( $( "#ide" ).val() );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.ide"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isValidNum( $( "#iza" ).val() );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.iza"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isBetween( $( "#iza" ).val(), 0, 90 );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.iza"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isValidNum( $( "#irp" ).val() );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.resolution"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isSup( $( "#irp" ).val(), 1 );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.resolution"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isValidNum( $( "#isr" ).val() );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.ratio"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }

        testOk = isSup( $( "#isr" ).val(), 1 );
        if( !testOk )
        {
            this.containerErrors.html( tapasTexts["label.ratio"] + " : " + tapasTexts["text.badvalue"] );
            this.containerErrors.show();
            return false;
        }
    },

    updateButtons: function()
    {
        if( 1 < this.nbRequest )
            this.delRequestButton.enable();
        else
            this.delRequestButton.disable();

        if( 9 <= this.nbRequest )
            this.addRequestButton.disable();
        else
            this.addRequestButton.enable();
    }

} );

</script>
